<!DOCTYPE html>
<html lang="en" xmlns="http://www.w3.org/1999/xhtml" xmlns:th="http://www.thymeleaf.org">
<head>
    <meta charset="UTF-8">
    <title>CurrendaTaskApp - Rafal Rutkowski</title>

    <link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/21.2.5/css/dx.light.css">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">

    <script type="text/javascript" src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
    <script type="text/javascript" src="https://cdn3.devexpress.com/jslib/21.2.5/js/dx.all.js"></script>
</head>
<body>
<div class="container" style="margin-top: 20px">
    <div class="row">
        <div class="col">
            <div class="card" id="cardRequest1">
                <div class="card-header">
                    Request 1
                </div>
                <div class="card-body">
                    <p class="card-text">
                        1. Dla zadnego zakresu dat (według dateOfEntry) i caseType zwraca liczbę spraw pogrupowaną według caseState

                        <div id="requestForm1"></div>
                        <div id="requestForm1Button"></div>
                    </p>
                </div>
            </div>
            <div class="card" id="cardRequest2" style="margin-top: 12px">
            <div class="card-header">
                Request 2
            </div>
            <div class="card-body">
                <p class="card-text">
                    2. Dla zadanego caseState zwraca adresy aktywnych stron

                <div id="requestForm2"></div>
                <div id="requestForm2Button"></div>
                </p>
            </div>
        </div>
        </div>
        <div class="col">
            <div class="card" id="cardResponse">
                <div class="card-header">
                    Last response status:
                    <p id="lastResponseStatus"></p>
                </div>
                <div class="card-body">
                    <p id="lastResponseBody"></p>
                </div>
            </div>
        </div>
    </div>
</div>
<script th:inline="javascript" type="text/javascript">
    CurrendaTaskHelper = {
        displayDateFormat: "yyyy-MM-dd",
        allCaseTypes: [[${allCaseTypes}]],

        convertDateToString: function(date){
            return new Date(date.getTime() - (date.getTimezoneOffset() * 60000 ))
                .toISOString()
                .split("T")[0];
        },

        onAjaxResponse: function (data, textStatus, jqXHR){
            $('#lastResponseBody').text(JSON.stringify(data));
            $('#lastResponseStatus').text(textStatus);
        }
    };

    $("#requestForm1").dxForm({
        formData: {dateFrom: null, dateTo: null, caseType: null},
        items: [
            {
                dataField: "dateFrom",
                label: {text:'dateFrom'},
                editorType: 'dxDateBox',
                editorOptions: {
                    displayFormat: CurrendaTaskHelper.displayDateFormat
            }},
            {
                dataField: "dateTo",
                label: {text:'dateTo'},
                editorType: 'dxDateBox',
                editorOptions: {
                    displayFormat: CurrendaTaskHelper.displayDateFormat
                }},
            {
                dataField: "caseType",
                label: {text:'caseType, available:' + CurrendaTaskHelper.allCaseTypes.join(", ")},
                editorOptions: {

                }}
        ]
    })

    $("#requestForm2").dxForm({
        formData: {caseType: null},
        items: [
            {
                dataField: "caseType",
                label: {text:'caseType, available:' + CurrendaTaskHelper.allCaseTypes.join(", ")},
                editorOptions: {

                }}
        ]
    })

    $('#requestForm1Button').dxButton({
        text: 'Send',
        onClick: function (){
            let formData = $('#requestForm1').dxForm("instance").option("formData");

            let requestData = Object.assign({}, formData);
            if(requestData.dateFrom != null){
                requestData.dateFrom = CurrendaTaskHelper.convertDateToString(requestData.dateFrom);
            }

            if(requestData.dateTo != null){
                requestData.dateTo = CurrendaTaskHelper.convertDateToString(requestData.dateTo);
            }

            let urlParams = new URLSearchParams(requestData).toString();

            $.ajax('/case/count-records-group-by-case-state?' + urlParams, {
                success: CurrendaTaskHelper.onAjaxResponse,
                error: CurrendaTaskHelper.onAjaxResponse,
            });
        }
    })

    $('#requestForm2Button').dxButton({
        text: 'Send',
        onClick: function (){
            let formData = $('#requestForm2').dxForm("instance").option("formData");

            let requestData = Object.assign({}, formData);
            let urlParams = new URLSearchParams(requestData).toString();

            $.ajax('/case/get-active-addresses?' + urlParams, {
                success: CurrendaTaskHelper.onAjaxResponse,
                error: CurrendaTaskHelper.onAjaxResponse,
            });
        }
    })
</script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
</body>
</html>